#include "main.h"
#include "apply_ops.h"
#include "regions.h"
#include "util.h"
#include "util_i.h"
#include "util_ops.h"
#include "util_gen.h"

int cal_cur_pos_ops(int num_ops, struct ops_list *ops, struct ops_list *new_ops, int sp_id, int seq1_len)
{
	int i, j;
	int num_new_ops;
	struct I dup_reg;
	int cut_point;
	int del_len;
	int dup_len;

	j = 0;
	for( i = 0; i < num_ops; i++ ) {
		if( ((ops[i].sign == '+') || (ops[i].sign == '-')|| (ops[i].sign == 'd') ) ) {
			new_ops[j] = assign_ops(ops[i]);
			new_ops[j].srcStart = ops[i].src_b;
			new_ops[j].srcEnd = ops[i].src_e;
			if( ops[i].sign != 'd' ) {
				new_ops[j].dstStart = ops[i].dst_b;
				new_ops[j].dstEnd = ops[i].dst_e;
				if( new_ops[j].srcStart >= new_ops[j].dstStart ) {
					dup_len = new_ops[j].dst_e - new_ops[j].dst_b;
					new_ops[j].srcStart = new_ops[j].srcStart + dup_len;
					new_ops[j].srcEnd = new_ops[j].srcEnd + dup_len;
				}
			}
			j++;
		}
	}

	num_new_ops = j;
	for( i = (num_new_ops-1); i >= 0; i-- )
	{
		if( (new_ops[i].sign == '+') || (new_ops[i].sign == '-') ) {
			cut_point = -1;
			del_len = 0;
			dup_reg = assign_I(new_ops[i].dstStart, new_ops[i].dstEnd);
			dup_len = new_ops[i].dst_e - new_ops[i].dst_b;
		}
		else if(new_ops[i].sign == 'd') {
			dup_len = 0;	
			cut_point = new_ops[i].srcStart;
			del_len = abs(new_ops[i].src_e - new_ops[i].src_b);
		}

		j = i;
		for( j = (num_new_ops-1); j > i; j-- )
		{
			if( (new_ops[i].sign == '+') || (new_ops[i].sign == '-') ) 
			{
				if( (new_ops[j].sign == '+') || (new_ops[j].sign == '-') )
				{
					if( new_ops[j].srcStart >= dup_reg.lower ) new_ops[j].srcStart = new_ops[j].srcStart + dup_len;
					if( new_ops[j].srcEnd >= dup_reg.lower ) new_ops[j].srcEnd = new_ops[j].srcEnd + dup_len;
					if( new_ops[j].dstStart >= dup_reg.lower ) new_ops[j].dstStart = new_ops[j].dstStart + dup_len;
					if( new_ops[j].dstEnd >= dup_reg.lower ) new_ops[j].dstEnd = new_ops[j].dstEnd + dup_len;
				}
				else if(new_ops[j].sign == 'd')  
				{
					if( new_ops[j].srcStart >= dup_reg.lower ) new_ops[j].srcStart = new_ops[j].srcStart + dup_len;
					if( new_ops[j].srcEnd >= dup_reg.lower ) new_ops[j].srcEnd = new_ops[j].srcEnd + dup_len;
				}
				else {
					fatalf("unallowed operation in the new_ops list: %d\n", new_ops[j].sign);
				}
			}
			else if( new_ops[i].sign == 'd' ) {
				if( (new_ops[j].sign == '+') || (new_ops[j].sign == '-') )
				{
					if( new_ops[j].srcStart >= (cut_point + del_len)) {
						new_ops[j].srcStart = new_ops[j].srcStart - del_len;
					}
					else if( new_ops[j].srcStart >= cut_point ) {
						new_ops[j].srcStart = cut_point;
					}
			
					if( new_ops[j].srcEnd >= (cut_point + del_len)) {
						new_ops[j].srcEnd = new_ops[j].srcEnd - del_len;
					}
					else if( new_ops[j].srcEnd >= cut_point ) {
						new_ops[j].srcEnd = cut_point;
					}

					if( new_ops[j].dstStart >= (cut_point + del_len)) {
						new_ops[j].dstStart = new_ops[j].dstStart - del_len;
					}
					else if( new_ops[j].dstStart >= cut_point ) {
						new_ops[j].dstStart = cut_point;
					}

					if( new_ops[j].dstEnd >= (cut_point + del_len)) {
						new_ops[j].dstEnd = new_ops[j].dstEnd - del_len;
					}
					else if( new_ops[j].dstEnd >= cut_point ) {
						new_ops[j].dstEnd = cut_point;
					}
				}
				else if(new_ops[j].sign == 'd')  
				{
					if( new_ops[j].srcStart >= (cut_point + del_len)) {
						new_ops[j].srcStart = new_ops[j].srcStart - del_len;
					}
					else if( new_ops[j].srcStart >= cut_point ) {
						new_ops[j].srcStart = cut_point;
					}

					if( new_ops[j].srcEnd >= (cut_point + del_len)) {
						new_ops[j].srcEnd = new_ops[j].srcEnd - del_len;
					}
					else if( new_ops[j].srcEnd >= cut_point ) {
						new_ops[j].srcEnd = cut_point;
					}
				}
				else {
					fatalf("unallowed operation in the new_ops list: %d\n", new_ops[j].sign);
				}
			}
		}
	}

	j = 0;
	for( i = 0; i < num_new_ops; i++ ) {
		if( new_ops[i].sp_id == sp_id ) {
			new_ops[j] = assign_ops(new_ops[i]);
			if( sp_id == SELF2 ) {
				new_ops[j].srcStart = new_ops[j].srcStart - seq1_len;
				new_ops[j].srcEnd = new_ops[j].srcEnd - seq1_len;
				if( new_ops[j].sign != 'd' ) {
					new_ops[j].dstStart = new_ops[j].dstStart - seq1_len;
					new_ops[j].dstEnd = new_ops[j].dstEnd - seq1_len;
				}
			}
			j++;
		}
	}
	num_new_ops = j;

	return(num_new_ops);
}
